/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                                  //
//                             . ..                        //
//                                                                         //
//         : TAirport.cpp                                              //
//                                                                         //
//   :               //
//               												   //
//                                                                         //
//  ()   :  ..,  ..,  ..                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "TAirport.h"

namespace NS_MANAGEMENT_AIRPORT{
	TAirport::TAirport(int NumberAirport)
	{
		this->NumberAirport = NumberAirport;
		this->Flights_data.clear();
	}

	TAirport::~TAirport(void)
	{
		this->Flights_data.clear();
	}
/**
* :
*       
* :
*   NumberFlight -  
*   name -  
*   price -  
*   startAirport -  ,    
*   finishAirport -  ,    
*  :
*    
*/
	int TAirport::addFlight(int NumberFlight, string name, int price, int startAirport, int finishAirport)
	{
		//  ,      
		if( (startAirport  != this->NumberAirport)&&
			(finishAirport != this->NumberAirport)){
			return -1;
		}
		TFlightLink pTFlightLink;
		//  
		pTFlightLink.startingAirport = startAirport;
		pTFlightLink.finishAirport   = finishAirport;
		pTFlightLink.name            = name;
		pTFlightLink.price           = price;
		pTFlightLink.countArmoring   = 0;
		//      
		if(isFlightsExist(NumberFlight))
		{
			return -2;
		}
		//   
		this->Flights_data.insert(TAirportStruct::value_type(NumberFlight, pTFlightLink));
		return 0;
	}
/**
* :
*     
* :
*   NumberFlight -  
*   pTFlightLink -  ,  
*  :
*    
*   -1 -      
*/
	int TAirport::getFlight     (int NumberFlight, TFlightLink &pTFlightLink)
	{
		if(!isFlightsExist(NumberFlight))
		{
			return -1;
		}
		pTFlightLink.countArmoring   = this->Flights_data[NumberFlight].countArmoring;
		pTFlightLink.finishAirport   = this->Flights_data[NumberFlight].finishAirport;
		pTFlightLink.startingAirport = this->Flights_data[NumberFlight].startingAirport;
		pTFlightLink.price           = this->Flights_data[NumberFlight].price;
		pTFlightLink.name            = this->Flights_data[NumberFlight].name;
		return 0;
	}
/**
* :
*    
* :
*   NumberFlight -  
*  :
*    
*/
	int TAirport::removeFlight(int NumberFlight)
	{
		//    
		if(!isFlightsExist(NumberFlight))
		{
			//   ,      ,   
			// ,          
			return 1;
		}
		this->Flights_data.erase(NumberFlight);
		return 0;
	}
/**
* :
*      
* :
*   NumberFlight -  
*  :
*    
*   -1 -      
*/
	int TAirport::armoringTicket(int NumberFlight)
	{
		//    
		if(!isFlightsExist(NumberFlight)){
			return -1;
		}
		//    
		this->Flights_data[NumberFlight].countArmoring++;
        //     
		return (this->Flights_data[NumberFlight].countArmoring);

	}
/**
* :
*      
* :
*   
*  :
*        
*/
	TAirportStruct * TAirport::getFlights()
	{
		TAirportStruct *pTAirportStruct;
		pTAirportStruct = &(this->Flights_data);
		return pTAirportStruct;
	}
/**
* :
*    ,    
* :
*   NumberFlight -  
*  :
*   true  - 
*   false -  
*/
	bool TAirport::isFlightsExist(int NumberFlight)
	{
		TAirportStruct ::const_iterator fe;
		fe = this->Flights_data.find (NumberFlight);
		if (fe == this->Flights_data.end()) 
		{
			return false;
		}
		else 
		{
			return true;
		}
	}
}